(*
Copyright 2011 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory List_Order_Impl
  imports List_Order
begin

type_synonym 'a list_ext_impl = "('a \<Rightarrow> 'a \<Rightarrow> bool \<times> bool) \<Rightarrow> 'a list \<Rightarrow> 'a list \<Rightarrow> bool \<times> bool"

locale list_order_extension_impl = list_order_extension s_list ns_list for
  s_list ns_list :: "'a list_ext" +
  fixes list_ext :: "'a list_ext_impl"
  assumes list_ext_s: "\<And> s ns. s_list {(a,b). s a b} {(a,b). ns a b} = {(as,bs). fst (list_ext (\<lambda> a b. (s a b, ns a b)) as bs)}"
     and  list_ext_ns: "\<And> s ns. ns_list {(a,b). s a b} {(a,b). ns a b} = {(as,bs). snd (list_ext (\<lambda> a b. (s a b, ns a b)) as bs)}"
    and s_ext_local_mono: "\<And> s ns s' ns' as bs. (set as \<times> set bs) \<inter> ns \<subseteq> ns' \<Longrightarrow> (set as \<times> set bs) \<inter> s \<subseteq> s' \<Longrightarrow> (as,bs) \<in> s_list ns s \<Longrightarrow> (as,bs) \<in> s_list ns' s'"
    and ns_ext_local_mono: "\<And> s ns s' ns' as bs. (set as \<times> set bs) \<inter> ns \<subseteq> ns' \<Longrightarrow> (set as \<times> set bs) \<inter> s \<subseteq> s' \<Longrightarrow> (as,bs) \<in> ns_list ns s \<Longrightarrow> (as,bs) \<in> ns_list ns' s'"

end

