(*
Copyright 2011 Christian Sternagel, René Thiemann

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Rec_Extension
imports Lexicographic_Extension Multiset_Extension Term RPO
begin

lemma lex_ext_singletons :
  assumes "fst (f a b) \<longrightarrow> snd (f a b)"
  shows "lex_ext_unbounded f [a] [b] = f a b"
proof-
  from assms(1) have "(fst (f a b) \<or> snd (f a b)) = snd (f a b)" by fast
  thus ?thesis unfolding lex_ext_unbounded_iff by simp
qed

lemma lex_mul_equiv:
  assumes "\<forall>a b. fst (f a b) \<longrightarrow> snd (f a b)"
  and "length ss \<le> 1"
  and "length ts \<le> 1"
  shows "lex_ext_unbounded f ss ts = mul_ext f ss ts"
proof (cases ss)
case Nil
  thus ?thesis
  proof (cases ts)
  case Nil thus ?thesis by (simp add: mul_ext_def lex_ext_unbounded_iff)
  next
  case (Cons z zs)
    with assms(3) have "zs = []" by simp
    with Cons and Nil show ?thesis by (simp add: mul_ext_def lex_ext_unbounded_iff)
  qed
next
case (Cons y ys) note Hyys = this
  with assms(2) have ys_e: "ys = []" by simp
  show ?thesis
  proof (cases ts)
  case Nil thus ?thesis by (simp add: mul_ext_def lex_ext_unbounded_iff)
  next
  case (Cons z zs)
    with assms(3) have zs_e: "zs = []" by simp
    from lex_ext_singletons[of f y z] and ys_e and zs_e and Cons and Hyys and
     mul_ext_singletons[rule_format, of f y z] and assms(1)
     show ?thesis by simp
  qed
qed

end